using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Drawing.Imaging; 
using System.IO;

namespace PlexityHide.GTP.WEB
{
	/// <summary>
	/// Summary description for GTPImg.
	/// </summary>

	public partial class GTPImg : System.Web.UI.Page
	{
	  // If you are tracing errors with image rendering set this to true, recompile, start a new browser and look at the 
	  // result from this request http://localhost/SamplesWeb/Sample1/GTPImg.aspx?log=true
    private bool Debug=false; 
    
    
    private void Page_Load(object sender, System.EventArgs e)
		{
      //System.Threading.Thread.Sleep(500);// Simulate slow connection
      string filename = Request.QueryString.Get("filename");
      string showlog = Request.QueryString.Get("log");
      if (showlog!=null)
      {
        ShowLog();
        return;
      }
      
      MemoryStream ms2=(MemoryStream)Page.Cache.Get(filename);
      if (ms2!=null)
      {
        if (Debug)
        {
          Page.Cache.Insert("DEBUG_"+filename,"Fetched",null,DateTime.Now.AddMinutes(20),TimeSpan.Zero);
        }
        Response.ContentType="image/png";
        ms2.WriteTo(Response.OutputStream);
      }
      else
      {
        // this is the normal case in design time
        System.Drawing.Image b=null;
        if (System.IO.File.Exists(filename))
        {
          b=System.Drawing.Image.FromFile(filename);
  
          try
          {
            Response.ContentType="image/png";
            MemoryStream ms=new MemoryStream();
            b.Save(ms,ImageFormat.Png);
            ms.WriteTo(Response.OutputStream);

            //b.Save(Response.OutputStream,ImageFormat.Jpeg);
            b.Dispose();
            System.IO.File.Delete(filename);
          }
          catch (Exception ee)
          {
            if (ee.Message!="")
            {
            };   		    
          }
        }
        else
        {
          // a cache miss... Why? Log it....
          if (Debug)
          {
            Page.Cache.Insert("DEBUG_"+filename,"Miss",null,DateTime.Now.AddMinutes(20),TimeSpan.Zero);
          }
          b=new System.Drawing.Bitmap(300,50);
          Graphics g=Graphics.FromImage(b);
          g.DrawString("Cache miss: "+filename,new Font("Ariel",8),new SolidBrush(Color.Black),Rectangle.FromLTRB(0,0,300,50),new StringFormat());

          Response.ContentType="image/png";
          MemoryStream ms=new MemoryStream();
          b.Save(ms,ImageFormat.Png);
          ms.WriteTo(Response.OutputStream);          
          b.Dispose();
          ms.Close();         
        
        }
              
      }
		}
		
		public void ShowLog()
		{
      if(!IsPostBack)
      {
        String myTable = "<table border=1><tr><td>Key</td><td>Value</td></tr>";
        IDictionaryEnumerator myEnum = this.Cache.GetEnumerator();
        while(myEnum.MoveNext())
        {
          myTable += "<tr><td>" + myEnum.Key + "</td>";
          string s=myEnum.Value.ToString();
          if (s.Length>100)
            s=s.Substring(0,100);
          myTable += "<td>" + s + "</td></tr>";
        }
        myTable += "</table>";
        Response.Write("<h2> The Keys and Values of the 'Cache' object are: </h2>");
        Response.Write(myTable);
      }
		
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);

		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
      this.Load += new System.EventHandler(this.Page_Load);

    }
		#endregion
	}
}
